UrlValidator (Grails 3.3.3)
Date: 2018-03-07

Package: org.grails.validation.routines

## [Java] Class UrlValidator

- org.grails.validation.routines.UrlValidator

- All Implemented Interfaces and Traits:
    java.io.Serializable

      @java.lang.Deprecated
      public class UrlValidator
      extends java.lang.Object

  URL Validation routines.

  Behavior of validation is modified by passing in options:
- ALLOW_2_SLASHES - [FALSE] Allows double '/' characters in the path component.
- NO_FRAGMENT- [FALSE] By default fragments are allowed, if this option is included then fragments are flagged as illegal.
- ALLOW_ALL_SCHEMES - [FALSE] By default only http, https, and ftp are considered valid schemes. Enabling this option will let any scheme pass validation.

Originally based in on php script by Debbie Dyer, validation.php v1.2b, Date: 03/07/02, http://javascript.internet.com. However, this validation now bears little resemblance to the php original.

       Example of usage:
       Construct a UrlValidator with valid schemes of "http", and "https".

        String[] schemes = {"http","https"}.
        UrlValidator urlValidator = new UrlValidator(schemes);
        if (urlValidator.isValid("ftp://foo.bar.com/")) {
           System.out.println("url is valid");
        } else {
           System.out.println("url is invalid");
        }

        prints "url is invalid"
       If instead the default constructor is used.

        UrlValidator urlValidator = new UrlValidator();
        if (urlValidator.isValid("ftp://foo.bar.com/")) {
           System.out.println("url is valid");
        } else {
           System.out.println("url is invalid");
        }

       prints out "url is valid"

deprecated:
  Replaced by newer version of commons-validation

See Also:
  Uniform Resource Identifiers (URI): Generic Syntax

Since:
  Validator 1.4

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static long` | `ALLOW_2_SLASHES` | Allow two slashes in the path component of the URL.
    `static long` | `ALLOW_ALL_SCHEMES` | Allows all validly formatted schemes to pass validation instead of supplying a set of valid schemes.
    `static long` | `NO_FRAGMENTS` | Enabling this options disallows any URL fragments.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `UrlValidator ()` Create a UrlValidator with default properties.
    `UrlValidator (java.lang.String[] schemes)` Behavior of validation is modified by passing in several strings options:
    `UrlValidator (long options)` Initialize a UrlValidator with the given validation options.
    `UrlValidator (java.lang.String[] schemes, long options)` Behavior of validation is modified by passing in options:
    `UrlValidator (RegexValidator authorityValidator, long options)` Initialize a UrlValidator with the given validation options.
    `UrlValidator (java.lang.String[] schemes, RegexValidator authorityValidator, long options)` Customizable constructor.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected int` | `countToken(java.lang.String token, java.lang.String target)` Returns the number of times the token appears in the target.
    `` | `static UrlValidator` | `getInstance()` Returns the singleton instance of this class with default schemes and options.
    `` | `boolean` | `isValid(java.lang.String value)`
    `` | `protected boolean` | `isValidAuthority(java.lang.String authority)` Returns true if the authority is properly formatted.
    `` | `protected boolean` | `isValidFragment(java.lang.String fragment)` Returns true if the given fragment is null or fragments are allowed.
    `` | `protected boolean` | `isValidPath(java.lang.String path)` Returns true if the path is valid.
    `` | `protected boolean` | `isValidQuery(java.lang.String query)` Returns true if the query is null or it's a properly formatted query string.
    `` | `protected boolean` | `isValidScheme(java.lang.String scheme)` Validate scheme.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### public static final long ALLOW_2_SLASHES

      Allow two slashes in the path component of the URL.

    - #### public static final long ALLOW_ALL_SCHEMES

      Allows all validly formatted schemes to pass validation instead of supplying a set of valid schemes.

    - #### public static final long NO_FRAGMENTS

      Enabling this options disallows any URL fragments.

  - ### Constructor Detail

    - #### public UrlValidator()

      Create a UrlValidator with default properties.

    - #### public UrlValidator(java.lang.String[] schemes)

      Behavior of validation is modified by passing in several strings options:

      Parameters:
        `schemes` - Pass in one or more url schemes to consider valid, passing in a null will default to "http,https,ftp" being valid. If a non-null schemes is specified then all valid schemes must be specified. Setting the ALLOW_ALL_SCHEMES option will ignore the contents of schemes.

    - #### public UrlValidator(long options)

      Initialize a UrlValidator with the given validation options.

      Parameters:
        `options` - The options should be set using the public constants declared in this class. To set multiple options you simply add them together. For example, ALLOW_2_SLASHES + NO_FRAGMENTS enables both of those options.

    - #### public UrlValidator(java.lang.String[] schemes, long options)

      Behavior of validation is modified by passing in options:

      Parameters:
        `schemes` - The set of valid schemes.
        `options` - The options should be set using the public constants declared in this class. To set multiple options you simply add them together. For example, ALLOW_2_SLASHES + NO_FRAGMENTS enables both of those options.

    - #### public UrlValidator(RegexValidator authorityValidator, long options)

      Initialize a UrlValidator with the given validation options.

      Parameters:
        `authorityValidator` - Regular expression validator used to validate the authority part
        `options` - Validation options. Set using the public constants of this class. To set multiple options, simply add them together:

        `ALLOW_2_SLASHES + NO_FRAGMENTS`

        enables both of those options.

    - #### public UrlValidator(java.lang.String[] schemes, RegexValidator authorityValidator, long options)

      Customizable constructor. Validation behavior is modifed by passing in options.

      Parameters:
        `schemes` - the set of valid schemes
        `authorityValidator` - Regular expression validator used to validate the authority part
        `options` - Validation options. Set using the public constants of this class. To set multiple options, simply add them together:

        `ALLOW_2_SLASHES + NO_FRAGMENTS`

        enables both of those options.

  - ### Method Detail

    - #### protected int countToken(java.lang.String token, java.lang.String target)

      Returns the number of times the token appears in the target.

      Parameters:
        `token` - Token value to be counted.
        `target` - Target value to count tokens in.
      Returns:
        the number of tokens.

    - #### public static UrlValidator getInstance()

      Returns the singleton instance of this class with default schemes and options.

      Returns:
        singleton instance with default schemes and options

    - #### public boolean isValid(java.lang.String value)

      Checks if a field has a valid url address.

      Parameters:
        `value` - The value validation is being performed on. A `null` value is considered invalid.
      Returns:
        true if the url is valid.

    - #### protected boolean isValidAuthority(java.lang.String authority)

      Returns true if the authority is properly formatted. An authority is the combination of hostname and port. A `null` authority value is considered invalid.

      Parameters:
        `authority` - Authority value to validate.
      Returns:
        true if authority (hostname and port) is valid.

    - #### protected boolean isValidFragment(java.lang.String fragment)

      Returns true if the given fragment is null or fragments are allowed.

      Parameters:
        `fragment` - Fragment value to validate.
      Returns:
        true if fragment is valid.

    - #### protected boolean isValidPath(java.lang.String path)

      Returns true if the path is valid. A `null` value is considered invalid.

      Parameters:
        `path` - Path value to validate.
      Returns:
        true if path is valid.

    - #### protected boolean isValidQuery(java.lang.String query)

      Returns true if the query is null or it's a properly formatted query string.

      Parameters:
        `query` - Query value to validate.
      Returns:
        true if query is valid.

    - #### protected boolean isValidScheme(java.lang.String scheme)

      Validate scheme. If schemes[] was initialized to a non null, then only those scheme's are allowed. Note this is slightly different than for the constructor.

      Parameters:
        `scheme` - The scheme to validate. A `null` value is considered invalid.
      Returns:
        true if valid.